<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_Image ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_Image extends AbstractStructArrayBase
{
    /**
     * The Images
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_Image[]
     */
    public $Images;
    /**
     * Constructor method for ArrayOfJPSOAP_Image
     * @uses ArrayOfJPSOAP_Image::setImages()
     * @param \StructType\JPSOAP_Image[] $images
     */
    public function __construct(array $images = array())
    {
        $this
            ->setImages($images);
    }
    /**
     * Get Images value
     * @return \StructType\JPSOAP_Image[]|null
     */
    public function getImages()
    {
        return $this->Images;
    }
    /**
     * This method is responsible for validating the values passed to the setImages method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImages method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImagesForArrayConstraintsFromSetImages(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_ImageImagesItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_ImageImagesItem instanceof \StructType\JPSOAP_Image) {
                $invalidValues[] = is_object($arrayOfJPSOAP_ImageImagesItem) ? get_class($arrayOfJPSOAP_ImageImagesItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_ImageImagesItem), var_export($arrayOfJPSOAP_ImageImagesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Images property can only contain items of type \StructType\JPSOAP_Image, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Images value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Image[] $images
     * @return \ArrayType\ArrayOfJPSOAP_Image
     */
    public function setImages(array $images = array())
    {
        // validation for constraint: array
        if ('' !== ($imagesArrayErrorMessage = self::validateImagesForArrayConstraintsFromSetImages($images))) {
            throw new \InvalidArgumentException($imagesArrayErrorMessage, __LINE__);
        }
        $this->Images = $images;
        return $this;
    }
    /**
     * Add item to Images value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Image $item
     * @return \ArrayType\ArrayOfJPSOAP_Image
     */
    public function addToImages(\StructType\JPSOAP_Image $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_Image) {
            throw new \InvalidArgumentException(sprintf('The Images property can only contain items of type \StructType\JPSOAP_Image, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Images[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_Image|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_Image|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_Image|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_Image|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_Image|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Images
     */
    public function getAttributeName()
    {
        return 'Images';
    }
}
